// last modified: 10AUG1999: updated for gcc-2.95

#include <string.h>
#include <stdlib.h>
#include <gtk--.h>
#include <gtk/gtk.h>


/*
 *  GuiDialogOAC: create a basic dialog dialog with 3 buttons 
 */
class GuiDialogOAC : public Gtk_Dialog
	{
	public: 
					GuiDialogOAC (char *winTitle=NULL, char *frameTitle=NULL);
					~GuiDialogOAC (); 
		virtual void		buildDialogWindow ();

	protected: 	
		virtual void 		fillVBox ();
		virtual void		fillActionArea ();
		virtual void 		buttonCallbackOK ();
		virtual void 		buttonCallbackApply ();
		virtual void 		buttonCallbackCancel ();
		virtual gint		delete_event_impl (GdkEventAny *e);


		Gtk_Button		d_buttonOK, 
					d_buttonApply, 
					d_buttonCancel;
  		Gtk_Frame		*d_baseFrame;
		char			*d_winTitle,
					*d_frameTitle;
	private:
	};



/*
 *  constructor: initialize everything 
 */
GuiDialogOAC::GuiDialogOAC(char *winTitle, char *frameTitle)
	      : Gtk_Dialog (),
		d_buttonOK ("OK"),
		d_buttonApply ("Apply"),
		d_buttonCancel ("Cancel")
{
	if (winTitle)
		d_winTitle = strdup (winTitle);
	else
		d_winTitle = strdup ("GuiDialogOAC Window");

	if (frameTitle)
		d_frameTitle = strdup (frameTitle);
	else
		d_frameTitle = NULL;

	this->set_position (GTK_WIN_POS_MOUSE);		
}


/*
 *  destructor: clean up, free allocated memory
 */
GuiDialogOAC::~GuiDialogOAC()
{
	if (d_winTitle) free (d_winTitle);	// c-type alloc from strdup
	if (d_frameTitle) free (d_frameTitle);	// c-type alloc from strdup
	if (d_baseFrame) delete d_baseFrame;
}


/*
 *  buildDialogWindow: 
 */
void GuiDialogOAC::buildDialogWindow ()
{
	this->set_usize (300, 120);
	this->set_title (d_winTitle);

	this->get_vbox()->set_border_width (2);

	fillVBox ();
	fillActionArea ();

	this->show ();
}


/*
 *  fillVBox: fill the dialog's VBox 
 */
void GuiDialogOAC::fillVBox ()
{
	if (d_frameTitle)
		{
		d_baseFrame = new Gtk_Frame (d_frameTitle);
		d_baseFrame->set_shadow_type (GTK_SHADOW_ETCHED_IN);
		d_baseFrame->set_border_width (6);
		this->get_vbox()->pack_start (*d_baseFrame, TRUE, TRUE, 0);
		d_baseFrame->show ();	
		}
	this->get_vbox()->show ();
}


/*
 *  fillActionArea: fill the dialog's action area
 */
void GuiDialogOAC::fillActionArea ()
{
	// create new hbox and add buttons to it
	connect_to_method (d_buttonOK.clicked, this, &GuiDialogOAC::buttonCallbackOK);
	this->get_action_area()->pack_start (d_buttonOK, TRUE, TRUE, 0);
	d_buttonOK.show ();

	connect_to_method (d_buttonApply.clicked, this, &GuiDialogOAC::buttonCallbackApply);
	this->get_action_area()->pack_start (d_buttonApply, TRUE, TRUE, 0);
	d_buttonApply.show ();

	connect_to_method (d_buttonCancel.clicked, this, &GuiDialogOAC::buttonCallbackCancel);
	this->get_action_area()->pack_start (d_buttonCancel, TRUE, TRUE, 0);
	d_buttonCancel.show ();
}


void GuiDialogOAC::buttonCallbackOK ()
{
	cout << "GuiDialogOAC: Default Callback OK\n";
}


void GuiDialogOAC::buttonCallbackApply ()
{
	cout << "GuiDialogOAC: Default Callback Apply\n";
}


void GuiDialogOAC::buttonCallbackCancel ()
{
	this->hide ();
}


gint GuiDialogOAC::delete_event_impl(GdkEventAny *)
{
	this->hide ();
	return (0);
}


int main (int argc, char *argv[])
{
	Gtk_Main	gtkMain (&argc, &argv);
	GuiDialogOAC	*testDialog;

	testDialog = new GuiDialogOAC ("GuiDialogOAC", "Test Frame");
	testDialog->buildDialogWindow ();
	testDialog->show ();
	gtkMain.run ();
}
