// last modified: 10AUG1999: updated for gcc-2.95

#include <iostream.h>
#include <stdio.h>
#include <strstream.h>
#include <string>
#include <gtk--.h>

//#ifdef HAVE_CONFIG_H
//#include <config.h>
//#endif

class test : public Gtk_Window 
{
	protected:
		Gtk_EventBox 	ebox;
		Gtk_VBox 	vbox;
		Gtk_Button 	closebutton;
		Gtk_HSeparator 	hsep;
	public:
		test();
		gint 		delete_event_impl(GdkEventAny*);
		void 		add(Gtk_Widget &w) { vbox.pack_start(w,FALSE,FALSE,0); }
};

class ItemFactoryTest : public test 
{
	public:
				ItemFactoryTest(void);
		void 		itemcallback(string m);
		void 		rbcallback(string m);
	private:
		gint 			buttonPress( GdkEventButton * event);
		Gtk_ItemFactory 	*itemf;
		Gtk_ObjectHandle<Gtk_MenuBar> mb;
		Gtk_ItemFactory 	*popupFactory;
		Gtk_ObjectHandle<Gtk_Menu>    popupMenu;
};


void ItemFactoryTest::itemcallback( string m) 
{
	cout << m << endl;
}


void ItemFactoryTest::rbcallback ( string m) 
{
	cout << m << endl;
}

class MessageReceiver 
{
public:
	void bonk( string s) 
		{
		cout << "messageReceiver:" << s << endl;
		}
} aReceiver;


ItemFactoryTest::ItemFactoryTest(void) :
		itemf( new Gtk_ItemFactory_MenuBar("<Main>")),
		mb(0),
		popupFactory(0),
		popupMenu(0)
{
	Gtk_Style			style; 
	Gtk_ObjectHandle<Gtk_MenuBar> 	mb;

	gdk_font_unref (style.gtkobj()->font);
	style.gtkobj()->font = gdk_font_load ("-*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-*");

    	{
        Gtk_ObjectHandle<Gtk_MenuBar> a(itemf->get_menubar_widget(""));
        mb = a;
        }

	g_return_if_fail(mb.get_object());
	mb->push_style (style);
	//itemf->push_style (*style);

	itemf->create_item( "/File", 		0, "<Branch>",0);
	itemf->create_item( "/File/New", 	0, "", 
		ItemFactoryConnector<ItemFactoryTest, string>(this,&ItemFactoryTest::itemcallback, 
			"RNG"));

	itemf->create_item( "/View", 		0, "<Branch>", 0);
	itemf->create_item( "/View/2D", 	0, "<RadioItem>", 
		ItemFactoryConnector<ItemFactoryTest, string>(this,&ItemFactoryTest::itemcallback, 
			"2D Plane"));
	itemf->create_item( "/View/3Da", 	0, "/View/2D", 
		ItemFactoryConnector<ItemFactoryTest, string>(this,&ItemFactoryTest::itemcallback, 
			"3D Wire"));
	itemf->create_item( "/View/3Db", 	0, "/View/2D", 
		ItemFactoryConnector<ItemFactoryTest, string>(this,&ItemFactoryTest::itemcallback, 
			"3D Height"));
	itemf->create_item( "/View/3Dc", 	0, "/View/2D", 
		ItemFactoryConnector<ItemFactoryTest, string>(this,&ItemFactoryTest::itemcallback, 
			"3D Light"));

	itemf->create_item( "/Colormap", 	0, "<Branch>", 0);
	itemf->create_item( "/Colormap/Color Bands", 0, "<RadioItem>", 0);
	itemf->create_item( "/Colormap/Grayscale", 0, "/Colormap/Color Bands", 0);

	{
	// can we avoid this kind of uglyness
	Gtk_ObjectHandle<Gtk_MenuBar> a(itemf->get_menubar_widget(""));
	mb = a;
	}

	g_return_if_fail(mb.get_object());
  
	vbox.pack_start(*mb, false,false,false);
	connect_to_method( ebox.button_press_event, this, &(ItemFactoryTest::buttonPress));
	mb->show();
}


int ItemFactoryTest::buttonPress( GdkEventButton * event) 
{
	cout << "buttonPress" << endl;
	if ( event->button == 3) 
		{
		strstream ss;
		string message;
    		ss << "/button pressed at x:" << event->x << " y: " << event->y << ends;
		message = ss.str();
		cout << "out with the old " << endl;
		delete popupFactory; // out with the old , and 
		cout << "in with the new" << endl;
		popupFactory = new Gtk_ItemFactory_Menu("<Main>"); // in with the new
		popupFactory->create_item(message, "", "<Item>", 
			      ItemFactoryConnector<ItemFactoryTest, string>
			      ( this, &(ItemFactoryTest::itemcallback), "message"));
		popupFactory->create_item(message, "", "<Item>",
			      ItemFactoryConnector<ItemFactoryTest, string>
			      ( this, &(ItemFactoryTest::itemcallback), "message"));

    		//popupMenu = static_cast<Gtk_ObjectHandle<Gtk_Menu>&> (popupFactory->get_menu_widget(""));
    		{
    		Gtk_ObjectHandle<Gtk_Menu> a(popupFactory->get_menu_widget(""));
    		popupMenu = a;
    		}
 
    		cout << "popupmenu " << ( popupMenu.owner() ? "owns " : " does not own ") << "the pointer" << endl;
    		//g_return_if_fail(popupMenu.get_object());
    		popupMenu->popup(0,0,event->button, event->time);
  		}
  	return 0;
}

test::test() 
{
	Gtk_Window::add(&ebox);
	ebox.add(vbox);
	ebox.show();
	set_usize(200,100);
	vbox.show();
	vbox.pack_start(hsep);
	vbox.pack_start(closebutton);
}

gint test::delete_event_impl(GdkEventAny* )
{
	hide();
	return 1;
}


int main(int argc, char *argv[]) 
{
	Gtk_Main m(&argc, &argv);
	ItemFactoryTest *ift = new ItemFactoryTest();

	ift->show();
	m.run();
	return 0;
}
